Bug 1717653 - python-astroid fails to build with Python 3.8
Summary: python-astroid fails to build with Python 3.8
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: python-astroid
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
urgent
Target Milestone: ---
Assignee: Christian Dersch
QA Contact: Fedora Extras Quality Assurance
URL: https://copr.fedorainfracloud.org/cop...
Whiteboard:
Depends On:
Blocks: PYTHON38 1697503
TreeView+ depends on / blocked
 
Reported: 2019-06-05 21:39 UTC by Miro Hrončok
Modified: 2019-07-12 13:53 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-07-12 13:53:16 UTC
Type: ---
Embargoed:


Attachments (Terms of Use)

Description Miro Hrončok 2019-06-05 21:39:13 UTC
python-astroid fails to build with Python 3.8.0b1. See https://copr.fedorainfracloud.org/coprs/g/python/python3.8/package/python-astroid/ for actual logs. This report is automated and not very verbose, but I'll get back here with details.

Comment 1 Miro Hrončok 2019-06-05 21:42:58 UTC
The failures are mostly about "Uninferable"

E       AssertionError: Uninferable is not true
E       TypeError: argument of type 'Uninferable' is not iterable
E           KeyError: (<function infer_named_tuple at 0x7fa5b9f02670>, <Call l.3 at 0x7fa5b9a738b0>)
E       TypeError: object of type 'Uninferable' has no len()
E           KeyError: (<function infer_named_tuple at 0x7fa5b9f02670>, <Call l.245 at 0x7fa5bb4e8d30>)
E       TypeError: object of type 'Uninferable' has no len()
E       TypeError: object of type 'Uninferable' has no len()
E       TypeError: object of type 'Uninferable' has no len()
E           KeyError: (<function infer_named_tuple at 0x7fa5b9f02670>, <Call l.3 at 0x7fa5b9b8cd00>)
E       TypeError: object of type 'Uninferable' has no len()
E       AssertionError: Uninferable != 'multiprocessing.managers'
E       AssertionError: Uninferable != 'queue.Queue'
E   AssertionError: Uninferable is not an instance of <class 'astroid.bases.Instance'>
E   AssertionError: Uninferable is not an instance of <class 'astroid.bases.Instance'>
...

Comment 2 Miro Hrončok 2019-06-05 21:57:32 UTC
See also bz1717662.

Comment 3 Miro Hrončok 2019-06-10 16:41:05 UTC
This issue is blocking the Python 3.8 rebuilds. If this package won't build with 3.8, it won't be installable, along with all its dependent packages, after the side tag is merged.
Furthermore, as it fails to install, its dependent packages will fail to install and/or build as well. The fix should be pushed on the master branch and no release bump is required.

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.8: https://copr.fedorainfracloud.org/coprs/g/python/python3.8/

This issue needs to be resolved by next week, if other rebuilds of Python 3.8 beta 1 go well. If this is unrealistic for you, let us know how much time you need.

If you don't have free cycles to dedicate fixing your package, notify us and we'll try to provide some pointers. Let us know if we can push a fix directly without a pull request, in the case we happen to have one before you do.

We recommend always consulting with upstream, chances are this is already fixed there.

Comment 4 Christian Dersch 2019-06-10 17:49:23 UTC
In upstream git I see several Python 3.8 related commits, however there is no release yet: https://github.com/PyCQA/astroid/commits/master

As I'm quite busy for the next two weeks and therefore might not be able to check whether a current git snapshot will fix our issue (and is in a good state in general, as there is https://github.com/PyCQA/astroid/issues/675), feel free to test and do that if you need it to unblock the rebuilds. Of course you can push a fix directly without pull request. Thanks!

Comment 5 Zbigniew Jędrzejewski-Szmek 2019-06-18 11:01:07 UTC
I tested the latest git master (981a139), and there's still many failures:
= 48 failed, 775 passed, 62 skipped, 15 xfailed, 1 xpassed, 1 warnings in 16.64 seconds =

Comment 6 Zbigniew Jędrzejewski-Szmek 2019-07-12 13:53:16 UTC
https://copr.fedorainfracloud.org/coprs/g/python/python3.8/build/968887/


Note You need to log in before you can comment on or make changes to this bug.